VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4425
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6270
   LinkTopic       =   "Form1"
   ScaleHeight     =   4425
   ScaleWidth      =   6270
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picCanvas 
      Height          =   2055
      Left            =   480
      ScaleHeight     =   1995
      ScaleWidth      =   2475
      TabIndex        =   0
      Top             =   360
      Width           =   2535
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub DrawShapes()
Const DASH_WIDTH = 120
Const SKIP_WIDTH = 120
Const PI = 3.14159265
Const NUM_SEGS = 50
Dim cx As Single
Dim cy As Single
Dim rx As Single
Dim ry As Single
Dim ptx() As Single
Dim pty() As Single
Dim i As Integer
Dim dtheta As Single

    picCanvas.Cls

    ' ***** Ellipse using Line *****
    cx = ScaleWidth * 0.25
    cy = ScaleHeight * 0.25
    rx = ScaleWidth * 0.2
    ry = ScaleHeight * 0.2

    ' Define the points' coordinates.
    ReDim ptx(0 To NUM_SEGS)
    ReDim pty(0 To NUM_SEGS)
    dtheta = 2 * PI / NUM_SEGS
    For i = 0 To NUM_SEGS
        ptx(i) = cx + rx * Cos(dtheta * i)
        pty(i) = cy + ry * Sin(dtheta * i)
    Next i

    ' Draw.
    picCanvas.DrawStyle = vbDash
    picCanvas.CurrentX = ptx(0)
    picCanvas.CurrentY = pty(0)
    For i = 1 To NUM_SEGS
        picCanvas.Line -(ptx(i), pty(i))
    Next i

    ' ***** Ellipse using DrawDashedPolyline *****
    cx = ScaleWidth * 0.75
    cy = ScaleHeight * 0.25
    rx = ScaleWidth * 0.2
    ry = ScaleHeight * 0.2

    ' Define the points' coordinates.
    ReDim ptx(0 To NUM_SEGS)
    ReDim pty(0 To NUM_SEGS)
    dtheta = 2 * PI / NUM_SEGS
    For i = 0 To NUM_SEGS
        ptx(i) = cx + rx * Cos(dtheta * i)
        pty(i) = cy + ry * Sin(dtheta * i)
    Next i

    ' Draw.
    picCanvas.DrawStyle = vbSolid
    DrawDashedPolyline picCanvas, ptx, pty, _
        DASH_WIDTH, SKIP_WIDTH

    ' ***** Rectangle using Line *****
    cx = ScaleWidth * 0.25
    cy = ScaleHeight * 0.75
    rx = ScaleWidth * 0.2
    ry = ScaleHeight * 0.2

    ' Define the points' coordinates.
    ReDim ptx(0 To 4)
    ReDim pty(0 To 4)
    ptx(0) = cx - rx
    pty(0) = cy - ry
    ptx(1) = cx + rx
    pty(1) = cy - ry
    ptx(2) = cx + rx
    pty(2) = cy + ry
    ptx(3) = cx - rx
    pty(3) = cy + ry
    ptx(4) = cx - rx
    pty(4) = cy - ry

    ' Draw.
    picCanvas.DrawStyle = vbDash
    picCanvas.CurrentX = ptx(0)
    picCanvas.CurrentY = pty(0)
    For i = 1 To 4
        picCanvas.Line -(ptx(i), pty(i))
    Next i

    ' ***** Rectangle using DrawDashedPolyline *****
    cx = ScaleWidth * 0.75
    cy = ScaleHeight * 0.75
    rx = ScaleWidth * 0.2
    ry = ScaleHeight * 0.2

    ' Define the points' coordinates.
    ReDim ptx(0 To 4)
    ReDim pty(0 To 4)
    ptx(0) = cx - rx
    pty(0) = cy - ry
    ptx(1) = cx + rx
    pty(1) = cy - ry
    ptx(2) = cx + rx
    pty(2) = cy + ry
    ptx(3) = cx - rx
    pty(3) = cy + ry
    ptx(4) = cx - rx
    pty(4) = cy - ry

    ' Draw.
    picCanvas.DrawStyle = vbSolid
    DrawDashedPolyline picCanvas, ptx, pty, _
        DASH_WIDTH, SKIP_WIDTH
End Sub
' Draw the polyline with dashed segments.
Private Sub DrawDashedPolyline(ByVal pic As Object, ptx() As Single, pty() As Single, Optional ByVal dash_length As Single = 60, Optional ByVal skip_length As Single = 60)
Dim skipping As Boolean
Dim dist_to_draw As Single
Dim pt As Integer
Dim x1 As Single
Dim y1 As Single
Dim x2 As Single
Dim y2 As Single

    ' Start drawing.
    skipping = False
    dist_to_draw = dash_length

    ' Start at (x1, y1).
    pt = LBound(ptx)
    x2 = ptx(pt)
    y2 = pty(pt)

    ' Draw the line segments.
    For pt = pt + 1 To UBound(ptx)
        ' Get the next point.
        x1 = x2
        y1 = y2
        x2 = ptx(pt)
        y2 = pty(pt)

        ' Draw between these points.
        DrawDashedSegment pic, _
            dash_length, skip_length, _
            x1, y1, x2, y2, _
            skipping, dist_to_draw
    Next pt
End Sub
' Draw a dashed segment from (x1, y1) to (x2, y2).
Private Sub DrawDashedSegment(ByVal pic As Object, ByVal dash_length As Single, ByVal skip_length As Single, ByVal x1 As Single, ByVal y1 As Single, ByVal x2 As Single, ByVal y2 As Single, ByRef skipping As Boolean, ByRef dist_to_draw As Single)
Dim ux As Single
Dim uy As Single
Dim dist As Single
Dim dist_this_piece As Single

    ' See how long the segment is.
    ux = x2 - x1
    uy = y2 - y1
    dist = Sqr(ux * ux + uy * uy)

    ' Do nothing if the segment has zero length.
    If dist < 0.00001 Then Exit Sub

    ' Get the segment's unit vector.
    ux = ux / dist
    uy = uy / dist

    ' Repeat until we use up the segment.
    Do
        ' See how far we should go.
        dist_this_piece = dist

        ' Make sure we don't exceed the total distance.
        If dist_this_piece > dist_to_draw Then dist_this_piece = dist_to_draw

        ' Go.
        If skipping Then
            If dist_this_piece > skip_length Then dist_this_piece = skip_length
            x1 = x1 + ux * dist_this_piece
            y1 = y1 + uy * dist_this_piece
        Else
            If dist_this_piece > dash_length Then dist_this_piece = dash_length
            x2 = x1 + ux * dist_this_piece
            y2 = y1 + uy * dist_this_piece
            pic.Line (x1, y1)-(x2, y2)
            x1 = x2
            y1 = y2
        End If

        ' Subtract the distance drawn.
        dist_to_draw = dist_to_draw - dist_this_piece
        dist = dist - dist_this_piece

        ' See if we finished this dash/skip.
        If dist_to_draw > 0 Then
            ' We did not finish. We ran out of segment.
            ' Exit to start the next segment.
            Exit Do
        Else
            ' We did finish. Start the next dash/skip
            ' on this segment.
            skipping = Not skipping
            If skipping Then
                dist_to_draw = skip_length
            Else
                dist_to_draw = dash_length
            End If
        End If
    Loop
End Sub


Private Sub Form_Paint()
    DrawShapes
End Sub
Private Sub Form_Resize()
    picCanvas.Move 0, 0, ScaleWidth, ScaleHeight
    DrawShapes
End Sub


